"""
requirements.py

Copyright 2013 Andres Riancho

This file is part of w3af, http://w3af.org/ .

w3af is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation version 2 of the License.

w3af is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with w3af; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

"""
from w3af.core.controllers.dependency_check.pip_dependency import PIPDependency

CORE = 1
GUI = 2

CORE_PIP_PACKAGES = [PIPDependency('clamd', 'clamd', '1.0.1'),
                     PIPDependency('github', 'PyGithub', '1.25.2'),
                     PIPDependency('git.util', 'GitPython', '0.3.2.RC1'),
                     PIPDependency('pybloomfilter', 'pybloomfiltermmap', '0.3.14'),
                     PIPDependency('esmre', 'esmre', '0.3.1'),
                     #PIPDependency('phply', 'phply', '1.0'),
                     #ORIG PIPDependency('nltk', 'nltk', '3.0.1'),
                     PIPDependency('nltk', 'nltk', '3.0.0'),
                     PIPDependency('chardet', 'chardet', '2.2.1'),
                     PIPDependency('tblib', 'tblib', '1.0.1'),
                     PIPDependency('pdfminer', 'pdfminer', '20140328'),
                     PIPDependency('concurrent.futures', 'futures', '2.1.6'),
                     #ORIG PIPDependency('OpenSSL', 'pyOpenSSL', '0.15.1'),
                     PIPDependency('OpenSSL', 'pyOpenSSL', '0.13.1'),
                     #ORIG PIPDependency('ndg', 'ndg-httpsclient', '0.3.3'),
                     PIPDependency('ndg', 'ndg-httpsclient', '0.3.2'),

                     # We need 0.1.7 because of mitmproxy
                     PIPDependency('pyasn1', 'pyasn1', '0.1.7'),

                     # Orig PIPDependency('lxml', 'lxml', '3.4.4'),
                     PIPDependency('lxml', 'lxml', '3.3.6'),
                     #PIPDependency('scapy.config', 'scapy-real', '2.2.0'),
                     PIPDependency('guess_language', 'guess-language', '0.2'),
                     PIPDependency('cluster', 'cluster', '1.1.2'),
                     PIPDependency('msgpack', 'msgpack-python', '0.4.6'),
                     PIPDependency('ntlm', 'python-ntlm', '1.0.1'),
                     PIPDependency('Halberd', 'halberd', '0.2.4'),
                     PIPDependency('darts.lib.utils', 'darts.util.lru', '0.5'),
                     PIPDependency('jinja2', 'Jinja2', '2.7.3'),
                     PIPDependency('vulndb', 'vulndb', '0.0.17'),
                     PIPDependency('markdown', 'markdown', '2.6.2'),

                     # This was used for testing, but now it's required for
                     # regular users too, do not remove!
                     PIPDependency('psutil', 'psutil', '2.2.1'),

                     # We "outsource" the HTTP proxy feature to mitmproxy
                     PIPDependency('mitmproxy', 'mitmproxy', '0.12.1'),

                     # https://gist.github.com/andresriancho/cf2fa1ce239b30f37bd9
                     PIPDependency('ruamel.ordereddict',
                                   'ruamel.ordereddict',
                                   '0.4.8'),

                     # Only used by the REST API, but in the future the console
                     # and GUI will consume it so it's ok to put this here
                     PIPDependency('Flask', 'Flask', '0.10.1'),
                     ]

GUI_PIP_EXTRAS = [PIPDependency('xdot', 'xdot', '0.6')]

GUI_PIP_PACKAGES = CORE_PIP_PACKAGES[:]
GUI_PIP_PACKAGES.extend(GUI_PIP_EXTRAS)
